VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form Form2 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Export VRML "
   ClientHeight    =   3348
   ClientLeft      =   6420
   ClientTop       =   2112
   ClientWidth     =   4656
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3348
   ScaleWidth      =   4656
   Begin VB.CommandButton About 
      Caption         =   "&About..."
      Height          =   375
      Left            =   1800
      TabIndex        =   11
      Top             =   2760
      Width           =   1092
   End
   Begin VB.CommandButton Command3 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   10
      Top             =   2760
      Width           =   1092
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Export"
      Default         =   -1  'True
      Height          =   375
      Left            =   240
      TabIndex        =   9
      Top             =   2760
      Width           =   1092
   End
   Begin VB.Frame Frame2 
      Caption         =   "Steps"
      Height          =   852
      Left            =   240
      TabIndex        =   4
      Top             =   1680
      Width           =   4212
      Begin VB.TextBox Text3 
         Height          =   288
         Left            =   3000
         TabIndex        =   6
         Text            =   "15"
         Top             =   360
         Width           =   852
      End
      Begin VB.TextBox Text2 
         Height          =   288
         Left            =   960
         TabIndex        =   5
         Text            =   "0"
         Top             =   360
         Width           =   852
      End
      Begin VB.Label Label3 
         Caption         =   "First frame"
         Height          =   372
         Left            =   120
         TabIndex        =   8
         Top             =   360
         Width           =   852
      End
      Begin VB.Label Label2 
         Caption         =   "Last Frame"
         Height          =   372
         Left            =   2040
         TabIndex        =   7
         Top             =   360
         Width           =   972
      End
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1920
      Top             =   -120
      _ExtentX        =   699
      _ExtentY        =   699
      _Version        =   327681
   End
   Begin VB.Frame Frame1 
      Caption         =   "File"
      Height          =   1332
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   4212
      Begin VB.CommandButton Command1 
         Caption         =   "Browse..."
         Height          =   372
         Left            =   2760
         TabIndex        =   2
         Top             =   840
         Width           =   1092
      End
      Begin VB.TextBox Text1 
         Height          =   300
         Left            =   720
         TabIndex        =   1
         Top             =   360
         Width           =   3132
      End
      Begin VB.Label Label1 
         Caption         =   "Name"
         Height          =   492
         Left            =   120
         TabIndex        =   3
         Top             =   360
         Width           =   732
      End
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Counter As Integer


Private Sub About_Click()
AboutBox.Show
End Sub

Private Sub Command1_Click()
'_________________________________________________________
' wm3dtowrl program
' Developed by Afzal Godil of the Information Technology Laboratory
' at the National Institute of Standards and Technology
' email: afzal.godil@nist.gov
'   url: http:/ovrt.nist.gov
' Program Based on Ken Tokusei  sample VB scripts
'________________________________________________________
    ' Set CancelError is True
    CommonDialog1.CancelError = True
    On Error GoTo ErrHandler
    ' Set flags
    
    CommonDialog1.Flags = cdlOFNHideReadOnly
    ' Set filters
    CommonDialog1.Filter = "All Files (*.*)|*.*|Text Files" & _
    "(*.txt)|*.txt|VRML Files (*.wrl)|*.wrl"
    ' Specify default filter
    CommonDialog1.FilterIndex = 3
    ' Display the Open dialog box
    CommonDialog1.ShowSave
    ' Display name of selected file
    
    ' MsgBox CommonDialog1.FileTitle
    If (CommonDialog1.filename <> "") Then
    Text1.Text = CommonDialog1.filename
    Counter = 0
    End If
    Exit Sub
    
ErrHandler:
    'User pressed the Cancel button
    Exit Sub
End Sub
Sub Main()
ssq = "rrrr"
End Sub

Private Sub Command2_Click()
    Dim MyFileSav As String, MyFile As String
    Dim respond

    If Counter = 1 Then
        MyFile = Text1.Text
        'MsgBox Counter
        Else
        MyFile = CommonDialog1.FileTitle
        'MsgBox MyFile
    End If
    MyFileSav = Text1.Text
    
    ' Prompt the user if s/he wishes to overwrite existing file
    If Dir(MyFile) <> "" Then
        reply = MsgBox("File already exists.  Overwrite?", vbYesNo + vbQuestion)
        If (reply = vbNo) Then
            Exit Sub
        End If
    End If
    
    If MyFile <> "" Then
        On Error GoTo ErrorHandler
        Open MyFileSav For Output As #1
    Else
        MsgBox "Please set the filename first.", vbExclamation
        Screen.MousePointer = vbDefault
        Exit Sub
    End If
    
    Screen.MousePointer = vbHourglass
    
    On Error GoTo ErrorHandler
    Dim app As Object, b1 As Object, b2 As Object
    Dim rad As Object, radius As Double
    Dim Stbody As String, bc As Object
    Dim view As Wm3d.view
    Dim cam As Wm3d.Camera
    Dim cx As Double, cy As Double, cz As Double
     Dim cox As Double, coy As Double, coz As Double
    Set app = GetObject(, "WM3D.Application")
    
    'app.Clear   ' Clear Err object in case error occurred.
     Set doc = app.ActiveDocument
     'sstr = doc.FullName
     'ssq = Mid(sstr, 1, InStr(sstr, "wm3") - 1) + "wrl"
     'MsgBox ssq
    'MsgBox sstr
    ' Write VRML header
      Dim CurrentFram As Integer
      CurrentFram = doc.CurrentFrame
     Dim Name1() As String
     Dim IDbody() As Integer
     Dim Mcolor() As Double
     Dim Transp() As Double
      nbody = doc.Bodies.Count
    
    If nbody = 0 Then
      MsgBox "Working Model 3D document contains no bodies.", vbExclamation
      Screen.MousePointer = vbDefault
      Close #1
      Exit Sub
    End If
       
    Dim iTime As Integer, iTime0 As Integer
    iTime = Text3.Text
    iTime0 = Text2.Text
      
    If iTime0 > iTime Then
        MsgBox "The first frame number must be less than the last frame number.", vbExclamation
        Screen.MousePointer = vbDefault
        Close #1
        Exit Sub
    ElseIf (iTime0 < 0) Then
        MsgBox "The first frame number must be greater than or equal to 0.", vbExclamation
        Screen.MousePointer = vbDefault
        Close #1
        Exit Sub
    End If
    
    
      ReDim Name1(nbody + 1)
      ReDim IDbody(nbody + 1)
      ReDim Mcolor(nbody + 1, 3) As Double
      ReDim Transp(nbody + 1)
       Set view = doc.Windows(1).view
       Set cam = view.Camera
       cam.GetConfig cx, cy, cz, cox, coy, coz
      ' MsgBox cx & cy & cz
       'MsgBox "orien" & " " & cox & " " & coy & " " & coz
       Dim Vec1(4) As Double
       
       junk = Rotation(cox, coy, -coz, Vec1)
       
      For ii = 1 To doc.Bodies.Count
           Set b2 = doc.Bodies(ii)
           Set bc = doc.Bodies(ii)
           Name1(ii) = b2.Name
           IDbody(ii) = b2.ID
           Mcolor(ii, 0) = bc.Color(wmColorRed).Value
           Mcolor(ii, 1) = bc.Color(wmColorGreen).Value
           Mcolor(ii, 2) = bc.Color(wmColorBlue).Value
           Transp(ii) = bc.Transparency
      Next ii
       
     Dim mtr1 As Object, mtrs As Object
     Dim Vec(4) As Double
     Dim ibody As Long
     Dim Data() As Double, tttt As Double
     Dim X1 As Double, Y1 As Double, Z1 As Double
     Dim RX As Double, RY As Double, RZ As Double
    
     ReDim Data(iTime + 2, nbody + 2, 7)

    ' Run the simulation
    For iT = 0 To iTime
      doc.RunTo (iT)
        For ibody = 1 To nbody
         Set mtr1 = doc.Bodies(ibody)
         qq = mtr1.GetConfig(X1, Y1, Z1, RX, RY, RZ)
         tttt = doc.Time
         Data(iT, ibody, 0) = tttt
   
         Data(iT, ibody, 1) = X1
         Data(iT, ibody, 2) = Y1
         Data(iT, ibody, 3) = Z1
         Data(iT, ibody, 4) = RX
         Data(iT, ibody, 5) = RY
         Data(iT, ibody, 6) = RZ
        Next ibody
    Next iT
     DelTime = Data(iTime, 1, 0) - Data(0, 1, 0)
     'MsgBox DelTime
     Print #1, "#VRML V2.0 utf8"
     Print #1, "Background {"
     Print #1, "skyColor [ 1.0 1.0 1.0 ]"
     Print #1, "}"
     Print #1, "DEF V3 Viewpoint {"
     Print #1, "position  " & Str(cx) & " " & Str(cy) & " " & Str(cz)
     Print #1, "orientation  " & Str(Vec1(0)) & " " & Str(Vec1(1)) & " " & Str(-Vec1(2)) & " " & Str(Vec1(3))
     Print #1, "description " + Chr(34) + " View: Wm3d view1 " + Chr(34)
     Print #1, "fieldOfView .605"
     Print #1, " }"
     Print #1, "DEF V2 Viewpoint {"
     Print #1, "position  " & Str(cx) & " " & Str(cy) & " " & Str(cz)
     Print #1, "orientation  " & Str(Vec1(0)) & " " & Str(Vec1(1)) & " " & Str(-Vec1(2)) & " " & Str(Vec1(3))
     Print #1, "description " + Chr(34) + " View: Wm3d view2 " + Chr(34)
     Print #1, "fieldOfView .405"
     Print #1, " }"
     
     Print #1, "Group  { "
     Print #1, "     children ["
     Print #1, "DirectionalLight {"
     Print #1, "direction " & Str(Vec1(0)) & " " & Str(Vec1(1)) & " " & Str(-Vec1(2)) & " "
     Print #1, "intensity .3"
     Print #1, "color 1.0 1.0 1.0 "
     Print #1, "   }"
     Print #1, "DirectionalLight {"
     Print #1, "direction " & Str(Vec1(0)) & " " & Str(-Vec1(1)) & " " & Str(Vec1(2)) & " "
     Print #1, "intensity .3"
     Print #1, "color 1.0 1.0 1.0 "
     Print #1, "   }"
     Print #1, "WorldInfo {"
     Print #1, "title  " + Chr(34) + " wm3dtowrl " + Chr(34)
     Print #1, "info["
     Print #1, Chr(34) + " wm3dtowrl, Developed at NIST by Information Technology Lab. " + Chr(34) + " ,"
     Print #1, Chr(34) + " Contact:      Afzal Godil    afzal.godil@nist.gov" + Chr(34) + " ,"
     Print #1, Chr(34) + "          and  Sandy Ressler  sressler@nist.gov " + Chr(34) + " ,"
     Print #1, Chr(34) + "          URL:  http://ovrt.nist.gov" + Chr(34)
     Print #1, "      ]"
     Print #1, "  }"
    
     Print #1, " DEF Main Transform {"
     'Print #1, "   rotation 1 0 0 -1.57 "
     Print #1, "    children ["
    For ii = 1 To doc.Bodies.Count
      Stbody = "DEF BodyX" & ii & " Transform {"
      Print #1, Stbody
      Print #1, "translation " & Str(Data(0, ii, 1)) & " " & Str(Data(0, ii, 2)) & " " & Str(Data(0, ii, 3))
      Print #1, "rotation 1 0 0  " & Str(Data(0, ii, 4))
      Print #1, "children ["
      Print #1, "DEF BodyY" & ii & " Transform {"
      Print #1, "rotation 0 1 0  " & Str(Data(0, ii, 5))
      Print #1, "children ["
      Print #1, "DEF BodyZ" & ii & " Transform {"
      Print #1, "rotation 0 0 1  " & Str(Data(0, ii, 6))
       
      Print #1, "children [ Shape { appearance Appearance {"
      Print #1, "material Material { diffuseColor " & Str(Mcolor(ii, 0)) & " " & Str(Mcolor(ii, 1)) & "  " & Str(Mcolor(ii, 2)) & " "
      Print #1, " transparency" & " " & Str(Transp(ii) * 0.5) & "}  }"
      
       ' Print #1, doc.Bodies.Count
        Set b1 = doc.Bodies(ii)
        'Name1(ii) = b1.Name
        'IDbody(ii) = b1.ID
        v = b1.Vertices
        If (b1.NumVertices = 0) Then
        radius = b1.radius
        'MsgBox radius
        Print #1, "geometry Sphere {radius " & Str(radius) & "}"
        Print #1, "    }"
        Print #1, "  ]"
        Print #1, "}"
        Print #1, "  ]"
        Print #1, "}"
        Print #1, "  ]"
        Print #1, "}"
        Else
        Print #1, "geometry  IndexedFaceSet {"
        Print #1, "convex FALSE"
         Print #1, "coord   Coordinate {  point ["
        If (IsArray(v)) Then
        'Print #1, b1.NumVertices, "no of ver"
      
            For i = 0 To b1.NumVertices - 1
               Print #1, Str$(v(i * 3)) + " " + Str$(v(i * 3 + 1)) + " " + Str$(v(i * 3 + 2)) + ","
            Next i
        End If
         Print #1, "]  }"
        End If
         
       
      If (b1.NumFaces = 0) Then
      Else
       Print #1, " coordIndex  ["
        f = b1.Faces
        If (IsArray(f)) Then
            Index = 0
            For i = 1 To b1.NumFaces
                NumVertices = f(Index)
                For j = 1 To NumVertices
                    Print #1, Str$(f(Index + j)) + ",";
                Next j
                Index = Index + NumVertices + 1
                Print #1, "-1,"
            Next i
        End If
    
        Print #1, "] } } ] }"
        Print #1, "  ]"
        Print #1, "}"
        Print #1, "  ]"
        Print #1, "}"
        End If
      Next ii
      Print #1, "]  }  ]  }"

    
     'Write the OrientationInterpolator
     'Key []
     'and KeyValue []
     '____________________________________________________
    For ibody = 1 To nbody
    Print #1, "DEF OBodyX" & ibody & "  OrientationInterpolator {"
    Print #1, "     key   [ "
    For iT = iTime0 To iTime
    Print #1, Str(Data(iT, ibody, 0) / DelTime)
    Next iT
    Print #1, "     ]"
    Print #1, "keyValue   ["
   
  For iT = iTime0 To iTime
    Print #1, "1.0 0.0 0.0 " & Str(Data(iT, ibody, 4))
    Next iT
    Print #1, "      ]"
    Print #1, "   }"
  Next ibody
    
  For ibody = 1 To nbody
    Print #1, "DEF OBodyY" & ibody & "  OrientationInterpolator {"
    Print #1, "     key   [ "
    For iT = iTime0 To iTime
    Print #1, Str(Data(iT, ibody, 0) / DelTime)
  Next iT
    Print #1, "     ]"
    Print #1, "keyValue   ["
   
  For iT = iTime0 To iTime
  
    Print #1, "0.0 1.0 0.0  " & Str(Data(iT, ibody, 5))
    Next iT
    Print #1, "      ]"
    Print #1, "   }"
  Next ibody
    
  For ibody = 1 To nbody
    Print #1, "DEF OBodyZ" & ibody & "  OrientationInterpolator {"
    Print #1, "     key   [ "
  For iT = iTime0 To iTime
         Print #1, Str(Data(iT, ibody, 0) / DelTime)
  Next iT
     Print #1, "     ]"
     Print #1, "keyValue   ["
    
  For iT = iTime0 To iTime
        Print #1, "0.0 0.0 1.0  " & Str(Data(iT, ibody, 6))
  Next iT
      Print #1, "      ]"
      Print #1, "   }"
  Next ibody
         
     'Write the PositionInterpolator
     'Key []
     'and KeyValue []
     '_______________________________________________________________
     
    For ibody = 1 To nbody
        Print #1, "DEF PBody" & ibody & "  PositionInterpolator {"
        Print #1, "     key   [ "
    For iT = iTime0 To iTime
        Print #1, Str(Data(iT, ibody, 0) / DelTime)
    Next iT
        Print #1, "     ]"
        Print #1, "keyValue   ["
    For iT = iTime0 To iTime
        Print #1, Str(Data(iT, ibody, 1)), Str(Data(iT, ibody, 2)), Str(Data(iT, ibody, 3))
    Next iT
        Print #1, "      ]"
        Print #1, "  }"
    Next ibody
    
    Print #1, "DEF Forever TimeSensor  {"
    Print #1, "cycleInterval 4.0 "
    Print #1, "loop TRUE"
    Print #1, "   }"
    '
    'Route
    'Route
    'Write the Route for each body
    'Route
    '_________________________________________________________________
  For ibody = 1 To nbody
    
    Print #1, "ROUTE Forever.fraction_changed TO OBodyX" & ibody & ".set_fraction"
    Print #1, "ROUTE Forever.fraction_changed TO OBodyY" & ibody & ".set_fraction"
    Print #1, "ROUTE Forever.fraction_changed TO OBodyZ" & ibody & ".set_fraction"
    Print #1, "ROUTE Forever.fraction_changed TO PBody" & ibody & ".set_fraction"
    
    Print #1, "ROUTE OBodyZ" & ibody & ".value_changed TO BodyZ" & ibody & ".set_rotation"
    Print #1, "ROUTE OBodyY" & ibody & ".value_changed TO BodyY" & ibody & ".set_rotation"
    Print #1, "ROUTE OBodyX" & ibody & ".value_changed TO BodyX" & ibody & ".set_rotation"
    Print #1, "ROUTE PBody" & ibody & ".value_changed TO BodyX" & ibody & ".set_translation"
  Next ibody
    
    'Closing the file #1
    'end
    doc.CurrentFrame = CurrentFram
    Close #1
    ' Done
    Screen.MousePointer = vbDefault
    MsgBox "Created the file " & MyFileSav, vbInformation
    End
    Exit Sub
    
  'Error-handling
  '___________________________________________________

ErrorHandler:       ' Error-handling routine.
    If Err.Number = 429 Then
       MsgBox "Please launch Working Model 3D first.", vbExclamation
       Screen.MousePointer = vbDefault
       'app.Clear
       Close #1
     Exit Sub
    End If
    If Err.Number = 91 Then
       MsgBox "Please open a document in Working Model 3D first.", vbExclamation
       Screen.MousePointer = vbDefault
       Close #1
     Exit Sub
    End If
    If Err.Number = 76 Then
       MsgBox "Path not found.", vbExclamation
       Screen.MousePointer = vbDefault
       Close #1
     Exit Sub
    End If
    If Err.Number = 75 Then
       MsgBox "Path/File access error.", vbExclamation
       Screen.MousePointer = vbDefault
       CommonDialog1.filename = ""
       Close #1
     Exit Sub
    End If
    If Err.Number = 13 Then
       MsgBox "Type mismatch error, requires a integer ", vbExclamation
       Screen.MousePointer = vbDefault
       CommonDialog1.filename = ""
       Close #1
     Exit Sub
    End If
    If Err.Number = 55 Then
       MsgBox "File is already open.", vbExclamation
       Screen.MousePointer = vbDefault
       Close #1
     Exit Sub
    End If
     If Err.Number = 32755 Then
       MsgBox "Please select a filename first.", vbExclamation
       Screen.MousePointer = vbDefault
       Close #1
     Exit Sub
    End If
       MsgBox "Program error (code " + Str$(Err.Number) + ")", vbExclamation
       Screen.MousePointer = vbDefault
       CommonDialog1.filename = ""
       Close #1
End Sub



Private Sub Command3_Click()
   End
End Sub

Public Sub Form_Load()
    Dim app1 As Object
    On Error GoTo NewErrorHandler
    Set app1 = GetObject(, "WM3D.Application")
    
    'app.Clear   ' Clear Err object in case error occurred.
    Set doc1 = app1.ActiveDocument
    sstr = doc1.FullName
    If doc1.NumFrames > 15 Then
        Text3.Text = doc1.NumFrames
    End If
    If (sstr <> "") Then
       i = InStr(1, sstr, ".wm3", 1)
       ssq = Mid(sstr, 1, i) + "wrl"
    Else
       sstr = doc1.Name
       ssq = app1.CurrentDirectory + "\" + sstr + ".wrl"
    End If
    CommonDialog1.filename = ssq
    Form2.Text1.Text = ssq
    Exit Sub
NewErrorHandler:            ' Error-handling routine.
    If Err.Number = 429 Then
       MsgBox "Please launch Working Model 3D first.", vbExclamation
       Screen.MousePointer = vbDefault
       'app.Clear
       End
     Exit Sub
    End If
    If Err.Number = 91 Then
       MsgBox "Please open a document in Working Model 3D first.", vbExclamation
       Screen.MousePointer = vbDefault
       End
     Exit Sub
    End If
    If Err.Number = 76 Then
       MsgBox "Path not found.", vbExclamation
       Screen.MousePointer = vbDefault
       Close #1
     Exit Sub
    End If
    If Err.Number = 75 Then
       MsgBox "Path/File access error.", vbExclamation
       Screen.MousePointer = vbDefault
       CommonDialog1.filename = ""
       Close #1
       End If
       If Err.Number = 55 Then
       MsgBox "File is already open.", vbExclamation
       Screen.MousePointer = vbDefault
       Close #1
     Exit Sub
    End If
     If Err.Number = 5 Then
       MsgBox "Please select a filename first.", vbExclamation
       Screen.MousePointer = vbDefault
       Close #1
     Exit Sub
    End If
End Sub

Private Sub Text1_Change()
   CommonDialog1.filename = Text1.Text
   Counter = 1
End Sub

Function Rotation(Xin, Yin, Zin, Vec)
Dim Mx(4) As Double
Dim My(4) As Double
Dim Mz(4) As Double
Dim Q1(4) As Double
Dim Q2(4) As Double
' Dim Vec(4) As Double
' Xin = 0.2
' Yin = 0.2
' Zin = 0.2
Mx(0) = 1# * Sin(Xin / 2#)
Mx(1) = 0#
Mx(2) = 0#
Mx(3) = Cos(Xin / 2#)

My(1) = 1# * Sin(Yin / 2#)
My(0) = 0#
My(2) = 0#
My(3) = Cos(Yin / 2#)

Mz(2) = 1# * Sin(Zin / 2#)
Mz(1) = 0#
Mz(0) = 0#
Mz(3) = Cos(Zin / 2#)



Q1(0) = My(3) * Mx(0) + My(0) * Mx(3) + My(1) * Mx(2) - My(2) * Mx(1)

Q1(1) = My(3) * Mx(1) + My(1) * Mx(3) + My(2) * Mx(0) - My(0) * Mx(2)

Q1(2) = My(3) * Mx(2) + My(2) * Mx(3) + My(0) * Mx(1) - My(1) * Mx(0)

Q1(3) = My(3) * Mx(3) + My(0) * Mx(0) + My(1) * Mx(1) - My(2) * Mx(2)

SSS = Sqr(Q1(0) * Q1(0) + Q1(1) * Q1(1) + Q1(2) * Q1(2) + Q1(3) * Q1(3))

Q1(0) = Q1(0) / SSS
Q1(1) = Q1(1) / SSS
Q1(2) = Q1(2) / SSS
Q1(3) = Q1(3) / SSS


Q2(0) = Mz(3) * Q1(0) + My(0) * Q1(3) + Mz(1) * Q1(2) - Mz(2) * Q1(1)

Q2(1) = Mz(3) * Q1(1) + Mz(1) * Q1(3) + Mz(2) * Q1(0) - Mz(0) * Q1(2)

Q2(2) = Mz(3) * Q1(2) + Mz(2) * Q1(3) + Mz(0) * Q1(1) - Mz(1) * Q1(0)

Q2(3) = Mz(3) * Q1(3) + Mz(0) * Q1(0) + Mz(1) * Q1(1) - Mz(2) * Q1(2)

SSS = Sqr(Q2(0) * Q2(0) + Q2(1) * Q2(1) + Q2(2) * Q2(2) + Q2(3) * Q2(3))

Q2(0) = Q2(0) / SSS
Q2(1) = Q2(1) / SSS
Q2(2) = Q2(2) / SSS
Q2(3) = Q2(3) / SSS

Length = Sqr(Q2(0) * Q2(0) + Q2(1) * Q2(1) + Q2(2) * Q2(2))
If (Length > 0.000001) Then
Dim tem As Double
tem = Q2(3)
Vec(3) = 2# * (Atn(-tem / Sqr(-tem * tem + 1)) + 2# * Atn(1#))

Vec(0) = Q2(0) / Length
Vec(1) = Q2(1) / Length
Vec(2) = Q2(2) / Length
Else
Vec(0) = 0#
Vec(1) = 0#
Vec(2) = 0#
Vec(3) = 0#
End If
'MsgBox Vec(3) & "   " & Vec(0) & "    " & Vec(1) & "     " & Vec(2)
End Function

